------------------------------------------------------------------------------
--                                                                          --
--                               AstroFrames                                --
--                                                                          --
--                      LOCATION_DIALOG_PKG.CALLBACKS                       --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                            $Revision: 1.3 $
--                                                                          --
--                       Copyright (C) 2001 Ed Falis                        --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This software  is maintained by Ed Falis (falis@adelphia.net)            --
--                                                                          --
------------------------------------------------------------------------------

with Location_Controllers;
use Location_Controllers;

--  Handle callbacks from default location dialog
package body Location_Dialog_Pkg.Callbacks is

   ------------------------------
   -- On_Cancel_Button_Clicked --
   ------------------------------

   procedure On_Cancel_Button_Clicked
     (Object : access Gtk_Button_Record'Class;
      Controller : Controller_Ptr)
   is
   begin
      Close_Dialog (Location_Controller (Controller.all)'Access);
   end On_Cancel_Button_Clicked;

   --------------------------
   -- On_OK_Button_Clicked --
   --------------------------

   procedure On_OK_Button_Clicked
     (Object : access Gtk_Button_Record'Class;
      Controller : Controller_Ptr)
   is
   begin
      Update_All (Location_Controller (Controller.all)'Access);
   end On_OK_Button_Clicked;

   ------------------
   -- Select_Field --
   ------------------

   function Select_Field
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args;
      Controller : Controller_Ptr) return Boolean
   is
   begin
      Select_Region
        (Gtk_Entry_Record (Object.all)'Access, 0);
      return True;
   end Select_Field;

   --------------------
   -- Unselect_Field --
   --------------------

   function Unselect_Field
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args;
      Controller : Controller_Ptr) return Boolean
   is
   begin
      Select_Region
        (Gtk_Entry_Record (Object.all)'Access, 0, 0);
      return True;
   end Unselect_Field;
end Location_Dialog_Pkg.Callbacks;
